// $Id:$
//
// Copyright (c) 2006
//      The Regents of the University of California.  All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that: (1) source code distributions
// retain the above copyright notice and this paragraph in its entirety, (2)
// distributions including binary code include the above copyright notice and
// this paragraph in its entirety in the documentation or other materials
// provided with the distribution, and (3) all advertising materials mentioning
// features or use of this software display the following acknowledgement:
// ``This product includes software developed by the University of California,
// Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
// the University nor the names of its contributors may be used to endorse
// or promote products derived from this software without specific prior
// written permission.
// THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
// WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
// MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#include "TCP_Rewriter.h"
#include "UDP_Rewriter.h"

// The following two are called from .bif's to obtain handle of Rewriter.
Rewriter* get_trace_rewriter(Val* conn_val)
	{
	Connection* conn = (Connection*) conn_val->AsRecordVal()->GetOrigin();
	return get_trace_rewriter(conn);
	}

Rewriter* get_trace_rewriter(Connection* conn)
	{
	if ( ! conn ||
	     (conn->ConnTransport() != TRANSPORT_TCP &&
	      conn->ConnTransport() != TRANSPORT_UDP) )
		internal_error("connection for the trace rewriter does not exist");

	Rewriter* rewriter = conn->TraceRewriter();
	if ( rewriter )
		return rewriter;

	if ( ! transformed_pkt_dump )
		return 0;	// okay if we don't have an output file

	else if ( ! conn->RewritingTrace() )
		builtin_run_time("flag rewriting_..._trace is not set properly");
	else
		internal_error("trace rewriter not initialized");

	return 0;
	}
